import * as ts from 'typescript';
export declare namespace CompileOptions {
    function getConfigFilePath(options: ts.CompilerOptions): string | undefined;
    function getDefaultOptions(configFileName?: string): ts.CompilerOptions;
}
export declare namespace LanguageServiceHost {
    function useSourceOfProjectReferenceRedirect(host: ts.LanguageServiceHost, value: () => boolean): void;
}
export declare namespace Type {
    function isObjectType(type: ts.Type): type is ts.ObjectType;
    function isTypeReference(type: ts.ObjectType): type is ts.TypeReference;
    function isVoidType(type: ts.Type): type is ts.Type;
    function isNullType(type: ts.Type): boolean;
    function isUndefinedType(type: ts.Type): boolean;
}
export declare class Symbols {
    private readonly typeChecker;
    constructor(typeChecker: ts.TypeChecker);
    static readonly Unknown = "unknown";
    static readonly Undefined = "undefined";
    static readonly None = "none";
    static isClass(symbol: ts.Symbol): boolean;
    static isInterface(symbol: ts.Symbol): boolean;
    static isTypeLiteral(symbol: ts.Symbol): boolean;
    static isAliasSymbol(symbol: ts.Symbol): boolean;
    static isTypeAlias(symbol: ts.Symbol): boolean;
    static isPrototype(symbol: ts.Symbol): boolean;
    static isRegularEnum(symbol: ts.Symbol): boolean;
    static isProperty(symbol: ts.Symbol): boolean;
    static isOptional(symbol: ts.Symbol): boolean;
    static getParent(symbol: ts.Symbol): ts.Symbol | undefined;
    createKey(symbol: ts.Symbol): string;
    computeBaseSymbolsForClass(symbol: ts.Symbol): ts.Symbol[] | undefined;
    computeBaseSymbolsForInterface(symbol: ts.Symbol): ts.Symbol[] | undefined;
    getTypeOfSymbol(symbol: ts.Symbol): ts.Type;
    private inferLocationNode;
}
